'--------------------------------------------------------------------------
'         VHF/UHF REPEATER CONTROLLER WITH MORSE IDENTIFIER
'                AND TIME OUT TIMER WARNING SIGNAL
'                       FINAL VERSION 1.04
'                 ANTRAK-BARBAROS ASUROGLU-TA2CBA
'                            03-03-2003
'--------------------------------------------------------------------------
         COR VAR PortB.4
         TX  VAR PortA.1
         TXINH VAR PortA.0
         ID_OUT VAR PORTB.0
         TEST   VAR PORTB.3
         TEST2  VAR PORTB.2

         index VAR Word
         index2 VAR Word
         index3 VAR Word

         Hit VAR Byte

         delaydot VAR WORD
         delaydash VAR WORD
         space1 VAR WORD
         space2 VAR WORD

         TOT CON 4500
         delay CON 70
         intdelay CON 59
         limit CON 3

         OPTION_REG.7 = 0        ' Enable PORTB pullups
'--------------------------[ INIT VARIABLES ]------------------------------
         TrisA = 0
         TrisB = 0
         TrisB.2 = 1
         TrisB.3 = 1
         TrisB.4 = 1
         PortA = 0
         PortB = 0
         Pause 3000
         Gosub POWER
'---------------------------[ MAIN PROGRAM ]-------------------------------
Main:
         For index = 0 to 60000
         TX = 0 : TXINH = 1

         If TEST = 0 then
         Gosub MORSE_ID
         Endif

         If TEST2 = 0 then
         Gosub TONE
         Endif

         If COR = 0 then PTT
         Pause 10
         Next

         Gosub MORSE_ID
         Gosub MORSE_ID

         Goto Main

PTT:     For index = 0 to TOT
         TX = 1 : TXINH = 0
         Pause 10
         If COR = 1 then End_1
         Next
         Gosub inter

End_1:   Pause 500
         TX = 0 : TXINH = 1
         Goto Main

'--------------------[ INTERFERENCE SUBROUTINE ]-----------------------
inter:
         TX  = 0
         Hit = 0

TOT_WARNING:

      TX = 1 : TXINH = 0
      Pause 750
      For index3 = 0 to 2
      For index2 = 0 to 70    ' Freq 900 Hz.
      ID_OUT = 1
      Pauseus 555
      ID_OUT = 0
      Pauseus 555
      Next
      Pause 70
      Next
      Pause 500
      TX = 0 : TXINH = 1

         For index = 0 to intdelay
         TXINH = 1 : Pause 500 : TXINH = 0 : Pause 500
         If COR = 0 then
         Hit = Hit + 1
         Endif
         Next

         If Hit < limit then open
         Goto inter

open:    Gosub MORSE_ID

End_2:   Return
'--------------------[ MORSE REPEATER IDENTIFIER ]---------------------
MORSE_ID:

      delaydot = delay
      delaydash = delay * 3
      space1 = delay
      space2 = delay * 4

      TX = 1 : TXINH = 0
      Pause 1000

A:    Gosub NOKTA : Gosub bosluk1 : Gosub CIZGI
      Gosub bosluk2

N:    Gosub CIZGI : Gosub bosluk1 : Gosub NOKTA
      Gosub bosluk2

T:    Gosub CIZGI 
      Gosub bosluk2

R:    Gosub NOKTA : Gosub bosluk1 : Gosub CIZGI : Gosub bosluk1 : Gosub NOKTA
      Gosub bosluk2

AA:   Gosub NOKTA : Gosub bosluk1 : Gosub CIZGI
      Gosub bosluk2

K:    Gosub CIZGI : Gosub bosluk1 : Gosub NOKTA : Gosub bosluk1 : Gosub CIZGI
      Gosub bosluk2

      Gosub bosluk2

      TX = 0 : TXINH = 1

      Gosub bekle

      Return
'--------------------[ MORSE REPEATER POWER ON ]---------------------
POWER:
      delaydot = delay
      delaydash = delay * 3
      space1 = delay
      space2 = delay * 4

      TX = 1 : TXINH = 0
      Pause 1000

PPP:    Gosub NOKTA : Gosub bosluk1 : Gosub CIZGI : Gosub bosluk1 : Gosub CIZGI : Gosub bosluk1 : Gosub NOKTA
        Gosub bosluk2

OOO:    Gosub CIZGI : Gosub bosluk1 : Gosub CIZGI : Gosub bosluk1 : Gosub CIZGI
        Gosub bosluk2

WWW:    Gosub NOKTA : Gosub bosluk1 : Gosub CIZGI : Gosub bosluk1 : Gosub CIZGI
        Gosub bosluk2

EEE:    Gosub NOKTA 
        Gosub bosluk2

RRR:    Gosub NOKTA : Gosub bosluk1 : Gosub CIZGI : Gosub bosluk1 : Gosub NOKTA
        Gosub bosluk2

        Gosub bosluk2

OO:     Gosub CIZGI : Gosub bosluk1 : Gosub CIZGI : Gosub bosluk1 : Gosub CIZGI
        Gosub bosluk2

NNN:    Gosub CIZGI : Gosub bosluk1 : Gosub NOKTA
        Gosub bosluk2

        Gosub bosluk2

        TX = 0 : TXINH = 1

        Return

NOKTA:
      For index2 = 0 to delaydot    ' Freq 900 Hz.
      ID_OUT = 1
      Pauseus 555
      ID_OUT = 0
      Pauseus 555
      If COR = 0 then Main
      Next
      Return

CIZGI:
      For index2 = 0 to delaydash
      ID_OUT = 1
      Pauseus 555
      ID_OUT = 0
      Pauseus 555
      If COR = 0 then Main
      Next
      Return

bosluk1:
      For index2 = 0 to space1
      Pause 1
      If COR = 0 then Main
      Next
      Return

bosluk2:
      For index2 = 0 to space2
      Pause 1
      If COR = 0 then Main
      Next
      Return

bekle:
      For index2 = 0 to 2000
      Pause 1
      If COR = 0 then Main
      Next
      Return

'--------------------[ 900 Hz TEST TONE GENERATOR ]---------------------
TONE:
      TX = 1 : TXINH = 0
      Pause 750

LOOP: ID_OUT = 1
      Pauseus 555
      ID_OUT = 0
      Pauseus 555
      If TEST2 = 1 then Son
      Goto LOOP
Son:
      Pause 500
      TX = 0 : TXINH = 1
      Pause 100
      Return
