
; PicBasic Pro Compiler 2.46, (c) 1998, 2005 microEngineering Labs, Inc. All Rights Reserved.  
PM_USED			EQU	1

	INCLUDE	"16F84.INC"

RAM_START       		EQU	0000Ch
RAM_END         		EQU	0004Fh
RAM_BANKS       		EQU	00001h
BANK0_START     		EQU	0000Ch
BANK0_END       		EQU	0004Fh
EEPROM_START    		EQU	02100h
EEPROM_END      		EQU	0213Fh

R0              		EQU	RAM_START + 000h
R1              		EQU	RAM_START + 002h
R2              		EQU	RAM_START + 004h
R3              		EQU	RAM_START + 006h
R4              		EQU	RAM_START + 008h
R5              		EQU	RAM_START + 00Ah
R6              		EQU	RAM_START + 00Ch
R7              		EQU	RAM_START + 00Eh
R8              		EQU	RAM_START + 010h
FLAGS           		EQU	RAM_START + 012h
GOP             		EQU	RAM_START + 013h
RM1             		EQU	RAM_START + 014h
RM2             		EQU	RAM_START + 015h
RR1             		EQU	RAM_START + 016h
RR2             		EQU	RAM_START + 017h
_delaydash       		EQU	RAM_START + 018h
_delaydot        		EQU	RAM_START + 01Ah
_index           		EQU	RAM_START + 01Ch
_index2          		EQU	RAM_START + 01Eh
_index3          		EQU	RAM_START + 020h
_space1          		EQU	RAM_START + 022h
_space2          		EQU	RAM_START + 024h
_Hit             		EQU	RAM_START + 026h
_PORTL           		EQU	 PORTB
_PORTH           		EQU	 PORTA
_TRISL           		EQU	 TRISB
_TRISH           		EQU	 TRISA
#define _COR             	_PORTB_4
#define _TX              	_PORTA_1
#define _TXINH           	_PORTA_0
#define _ID_OUT          	_PORTB_0
#define _TEST            	_PORTB_3
#define _TEST2           	_PORTB_2
#define _PORTB_4         	 PORTB, 004h
#define _PORTA_1         	 PORTA, 001h
#define _PORTA_0         	 PORTA, 000h
#define _PORTB_0         	 PORTB, 000h
#define _PORTB_3         	 PORTB, 003h
#define _PORTB_2         	 PORTB, 002h
#define _OPTION_REG_7    	 OPTION_REG, 007h
#define _TRISB_2         	 TRISB, 002h
#define _TRISB_3         	 TRISB, 003h
#define _TRISB_4         	 TRISB, 004h

; Constants.
_TOT             		EQU	01194h
_delay           		EQU	00046h
_intdelay        		EQU	0003Bh
_limit           		EQU	00003h
	INCLUDE	"REPCONT.MAC"
	INCLUDE	"PBPPIC14.LIB"

	MOVE?CT	000h, _OPTION_REG_7
	MOVE?CB	000h, TRISA
	MOVE?CB	000h, TRISB
	MOVE?CT	001h, _TRISB_2
	MOVE?CT	001h, _TRISB_3
	MOVE?CT	001h, _TRISB_4
	MOVE?CB	000h, PORTA
	MOVE?CB	000h, PORTB
	PAUSE?C	00BB8h
	GOSUB?L	_POWER

	LABEL?L	_Main	
	MOVE?CW	000h, _index
	LABEL?L	L00001	
	CMPGT?WCL	_index, 0EA60h, L00002
	MOVE?CT	000h, _TX
	MOVE?CT	001h, _TXINH
	CMPNE?TCL	_TEST, 000h, L00003
	GOSUB?L	_MORSE_ID
	LABEL?L	L00003	
	CMPNE?TCL	_TEST2, 000h, L00005
	GOSUB?L	_TONE
	LABEL?L	L00005	
	CMPEQ?TCL	_COR, 000h, _PTT
	PAUSE?C	00Ah
	NEXT?WCL	_index, 001h, L00001
	LABEL?L	L00002	
	GOSUB?L	_MORSE_ID
	GOSUB?L	_MORSE_ID
	GOTO?L	_Main

	LABEL?L	_PTT	
	MOVE?CW	000h, _index
	LABEL?L	L00007	
	CMPGT?WCL	_index, _TOT, L00008
	MOVE?CT	001h, _TX
	MOVE?CT	000h, _TXINH
	PAUSE?C	00Ah
	CMPEQ?TCL	_COR, 001h, _End_1
	NEXT?WCL	_index, 001h, L00007
	LABEL?L	L00008	
	GOSUB?L	_inter

	LABEL?L	_End_1	
	PAUSE?C	001F4h
	MOVE?CT	000h, _TX
	MOVE?CT	001h, _TXINH
	GOTO?L	_Main

	LABEL?L	_inter	
	MOVE?CT	000h, _TX
	MOVE?CB	000h, _Hit

	LABEL?L	_TOT_WARNING	
	MOVE?CT	001h, _TX
	MOVE?CT	000h, _TXINH
	PAUSE?C	002EEh
	MOVE?CW	000h, _index3
	LABEL?L	L00009	
	CMPGT?WCL	_index3, 002h, L00010
	MOVE?CW	000h, _index2
	LABEL?L	L00011	
	CMPGT?WCL	_index2, 046h, L00012
	MOVE?CT	001h, _ID_OUT
	PAUSEUS?C	0022Bh
	MOVE?CT	000h, _ID_OUT
	PAUSEUS?C	0022Bh
	NEXT?WCL	_index2, 001h, L00011
	LABEL?L	L00012	
	PAUSE?C	046h
	NEXT?WCL	_index3, 001h, L00009
	LABEL?L	L00010	
	PAUSE?C	001F4h
	MOVE?CT	000h, _TX
	MOVE?CT	001h, _TXINH
	MOVE?CW	000h, _index
	LABEL?L	L00013	
	CMPGT?WCL	_index, _intdelay, L00014
	MOVE?CT	001h, _TXINH
	PAUSE?C	001F4h
	MOVE?CT	000h, _TXINH
	PAUSE?C	001F4h
	CMPNE?TCL	_COR, 000h, L00015
	ADD?BCB	_Hit, 001h, _Hit
	LABEL?L	L00015	
	NEXT?WCL	_index, 001h, L00013
	LABEL?L	L00014	
	CMPLT?BCL	_Hit, _limit, _open
	GOTO?L	_inter

	LABEL?L	_open	
	GOSUB?L	_MORSE_ID

	LABEL?L	_End_2	
	RETURN?	

	LABEL?L	_MORSE_ID	
	MOVE?CW	_delay, _delaydot
	MOVE?CW	0D2h, _delaydash
	MOVE?CW	_delay, _space1
	MOVE?CW	00118h, _space2
	MOVE?CT	001h, _TX
	MOVE?CT	000h, _TXINH
	PAUSE?C	003E8h

	LABEL?L	_A	
	GOSUB?L	_NOKTA
	GOSUB?L	_bosluk1
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk2

	LABEL?L	_N	
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk1
	GOSUB?L	_NOKTA
	GOSUB?L	_bosluk2

	LABEL?L	_T	
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk2

	LABEL?L	_R	
	GOSUB?L	_NOKTA
	GOSUB?L	_bosluk1
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk1
	GOSUB?L	_NOKTA
	GOSUB?L	_bosluk2

	LABEL?L	_AA	
	GOSUB?L	_NOKTA
	GOSUB?L	_bosluk1
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk2

	LABEL?L	_K	
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk1
	GOSUB?L	_NOKTA
	GOSUB?L	_bosluk1
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk2
	GOSUB?L	_bosluk2
	MOVE?CT	000h, _TX
	MOVE?CT	001h, _TXINH
	GOSUB?L	_bekle
	RETURN?	

	LABEL?L	_POWER	
	MOVE?CW	_delay, _delaydot
	MOVE?CW	0D2h, _delaydash
	MOVE?CW	_delay, _space1
	MOVE?CW	00118h, _space2
	MOVE?CT	001h, _TX
	MOVE?CT	000h, _TXINH
	PAUSE?C	003E8h

	LABEL?L	_PPP	
	GOSUB?L	_NOKTA
	GOSUB?L	_bosluk1
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk1
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk1
	GOSUB?L	_NOKTA
	GOSUB?L	_bosluk2

	LABEL?L	_OOO	
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk1
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk1
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk2

	LABEL?L	_WWW	
	GOSUB?L	_NOKTA
	GOSUB?L	_bosluk1
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk1
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk2

	LABEL?L	_EEE	
	GOSUB?L	_NOKTA
	GOSUB?L	_bosluk2

	LABEL?L	_RRR	
	GOSUB?L	_NOKTA
	GOSUB?L	_bosluk1
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk1
	GOSUB?L	_NOKTA
	GOSUB?L	_bosluk2
	GOSUB?L	_bosluk2

	LABEL?L	_OO	
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk1
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk1
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk2

	LABEL?L	_NNN	
	GOSUB?L	_CIZGI
	GOSUB?L	_bosluk1
	GOSUB?L	_NOKTA
	GOSUB?L	_bosluk2
	GOSUB?L	_bosluk2
	MOVE?CT	000h, _TX
	MOVE?CT	001h, _TXINH
	RETURN?	

	LABEL?L	_NOKTA	
	MOVE?CW	000h, _index2
	LABEL?L	L00017	
	CMPGT?WWL	_index2, _delaydot, L00018
	MOVE?CT	001h, _ID_OUT
	PAUSEUS?C	0022Bh
	MOVE?CT	000h, _ID_OUT
	PAUSEUS?C	0022Bh
	CMPEQ?TCL	_COR, 000h, _Main
	NEXT?WCL	_index2, 001h, L00017
	LABEL?L	L00018	
	RETURN?	

	LABEL?L	_CIZGI	
	MOVE?CW	000h, _index2
	LABEL?L	L00019	
	CMPGT?WWL	_index2, _delaydash, L00020
	MOVE?CT	001h, _ID_OUT
	PAUSEUS?C	0022Bh
	MOVE?CT	000h, _ID_OUT
	PAUSEUS?C	0022Bh
	CMPEQ?TCL	_COR, 000h, _Main
	NEXT?WCL	_index2, 001h, L00019
	LABEL?L	L00020	
	RETURN?	

	LABEL?L	_bosluk1	
	MOVE?CW	000h, _index2
	LABEL?L	L00021	
	CMPGT?WWL	_index2, _space1, L00022
	PAUSE?C	001h
	CMPEQ?TCL	_COR, 000h, _Main
	NEXT?WCL	_index2, 001h, L00021
	LABEL?L	L00022	
	RETURN?	

	LABEL?L	_bosluk2	
	MOVE?CW	000h, _index2
	LABEL?L	L00023	
	CMPGT?WWL	_index2, _space2, L00024
	PAUSE?C	001h
	CMPEQ?TCL	_COR, 000h, _Main
	NEXT?WCL	_index2, 001h, L00023
	LABEL?L	L00024	
	RETURN?	

	LABEL?L	_bekle	
	MOVE?CW	000h, _index2
	LABEL?L	L00025	
	CMPGT?WCL	_index2, 007D0h, L00026
	PAUSE?C	001h
	CMPEQ?TCL	_COR, 000h, _Main
	NEXT?WCL	_index2, 001h, L00025
	LABEL?L	L00026	
	RETURN?	

	LABEL?L	_TONE	
	MOVE?CT	001h, _TX
	MOVE?CT	000h, _TXINH
	PAUSE?C	002EEh

	LABEL?L	_LOOP	
	MOVE?CT	001h, _ID_OUT
	PAUSEUS?C	0022Bh
	MOVE?CT	000h, _ID_OUT
	PAUSEUS?C	0022Bh
	CMPEQ?TCL	_TEST2, 001h, _Son
	GOTO?L	_LOOP

	LABEL?L	_Son	
	PAUSE?C	001F4h
	MOVE?CT	000h, _TX
	MOVE?CT	001h, _TXINH
	PAUSE?C	064h
	RETURN?	

	END
